{ ====================================================================
application bundle specifics

Copyright 2013 Roelf Toxopeus

SwiftForth version.
define the Info.plist, pkginfo and apprun files here.
Note: the executable is apprun by default
     the app icon is app.icns by default
Last: 29 July 2020 at 13:06:08 CEST  -rt
==================================================================== }

{ --------------------------------------------------------------------
The Info.plist and pkginfo file contents:

(TXTLINE) -- parse entire line and 'compile' it as a string without count
or terminating zero.
TXTLINE+ -- (TXTLINE) and add a trailing linefeed.
TXTLINE -- (TXTLINE) and add a trailing zero and align, like ,Z" but without
quotes!

INFO.PLIST$1 -- first part of default Info.plist file as a string.
Goes up to
 <key>CFBundleExecutable</key>
 <string>
Used to write out to new Info.plist file in app bundle. Executable is
added and second part of default Info.plist file is written out.
INFO.PLIST$2 -- second part of default Info.plist. Starts at
 </string>
 <key>CFBundleIconFile</key>
Goes up to
 <key>CFBundleName</key>
 <string>
Used to write out to new Info.plist file in app bundle. App name is
added and third part of default Info.plist file is written out.
INFO.PLIST3 -- third part of default Info.plist. Starts at
 </string>
 <key>CFBundlePackageType</key>
and goes to end.

PKGINFO$ -- the PkgInfo string. Addjust if necessary.

See turnkey4.f
-------------------------------------------------------------------- }

/FORTH
DECIMAL

: (TXTLINE) ( <text> -- )   0 PARSE BL SKIP -TRAILING  HERE OVER ALLOT SWAP CMOVE ;

: TXTLINE+ ( <text> -- )  (TXTLINE) 10 C, ;

: TXTLINE ( <text> -- )   (TXTLINE) 0 C, ALIGN ;

CREATE INFO.PLIST$1
TXTLINE+ <?xml version="1.0" encoding="UTF-8"?>
TXTLINE+ <!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
TXTLINE+ <plist version=\"1.0\">
TXTLINE+ <dict>
TXTLINE+ <key>CFBundleAllowMixedLocalizations</key>
TXTLINE+ <string>true</string>
TXTLINE+ <key>CFBundleDevelopmentRegion</key>
TXTLINE+ <string>English</string>
TXTLINE+ <key>CFBundleExecutable</key>
TXTLINE <string>

CREATE INFO.PLIST$2
TXTLINE+ </string>
TXTLINE+ <key>CFBundleIconFile</key>
TXTLINE+ <string>app.icns</string>
TXTLINE+ <key>CFBundleInfoDictionaryVersion</key>
TXTLINE+ <string>6.0</string>
TXTLINE+ <key>CFBundleIdentifier</key>
TXTLINE+ <string>org.VFXForth.app</string>
TXTLINE+ <key>CFBundleName</key>
TXTLINE <string>

CREATE INFO.PLIST$3
TXTLINE+ </string>
TXTLINE+ <key>CFBundlePackageType</key>
TXTLINE+ <string>APPL</string>
TXTLINE+ <key>CFBundleSignature</key>
TXTLINE+ <string>mpe4</string>
TXTLINE+ <key>CFBundleVersion</key>
TXTLINE+ <string>1.0.5</string>
TXTLINE+ </dict>
TXTLINE </plist>

CREATE PKGINFO$
TXTLINE APPL4inc

{ --------------------------------------------------------------------
  The Info.plist and pkginfo files:
  
  INFOPLIST-FILE -- create Info.plist file, write out the plist strings to this
  file. Insert the given app name in plist.

  PKGINFO-FILE -- create the PKGInfo file, write out the default pkginfo.
-------------------------------------------------------------------- }

: ?WRITE-ERROR ( fid ior -- )
      ?DUP IF ." WRITE-FILE error !" SWAP CLOSE-FILE DROP THROW ELSE DROP THEN ;

: WRITE-PLIST ( a n fid -- )
   >R
   INFO.PLIST$1 ZCOUNT R@ WRITE-FILE R@ SWAP ?WRITE-ERROR
   2DUP R@ WRITE-FILE R@ SWAP ?WRITE-ERROR                \ CFBundleExecutable
   INFO.PLIST$2 ZCOUNT R@ WRITE-FILE R@ SWAP ?WRITE-ERROR
   R@ WRITE-FILE R@ SWAP ?WRITE-ERROR                     \ CFBundleName
   INFO.PLIST$3 ZCOUNT R@ WRITE-FILE R> SWAP ?WRITE-ERROR ;

: INFOPLIST-FILE ( a n -- )
   S" Info.plist" FILE DUP >R WRITE-PLIST R> CLOSE-FILE THROW ;
   
: WRITE-PKGINFO ( fid -- )
   DUP PKGINFO$ ZCOUNT ROT WRITE-FILE ?WRITE-ERROR ;

: PKGINFO-FILE ( -- )
   S" Pkginfo" FILE DUP >R WRITE-PKGINFO R> CLOSE-FILE THROW ;

\\ ( eof )