{ ====================================================================
bundlecheck

Copyright 2013 Roelf Toxopeus

Check we're launched from an appbundle or not. Allows to find our
resources.
Last: 7 January 2019 at 12:36:14 CEST  -rt
==================================================================== }

{ --------------------------------------------------------------------
BUNDLED? -- check we're bundled as .app bundle. Return usefull path
depending on flag:
true  -> return appbundlepath/Contents/
Usefull when we have to search through our bundled resources, frameworks, plugins etc.
false -> return macpath.
Note: zstring path !!!!!!!!!!

A non GUI app does have a main bundle!
The bundle path is the path to the folder the app is launched from.
All the standard bundle folders are found there as well. Some like
the Resource folder are the same as the the bundle path.
A possible Info.plist file goes in the bundle path as well.

.BUNDLE-INFO -- prints paths of bundle contents. Uses CoreFoundation's
CFBundle functions. It even prints the path of folders not existing,
i.e. it prints the path where such a folder should be if it existed!
-------------------------------------------------------------------- }

/FORTH
DECIMAL

s" .app/Contents/" NIP CONSTANT #KEEPCHARS

: BUNDLED? ( -- zstring f )
   PATHPAD DUP >R 1024 ERASE
   THIS-EXE-NAME 2DUP S" .app" SEARCH
               IF  NIP #KEEPCHARS - - R@ ZPLACE TRUE
         ELSE  2DROP 2DROP MACPATH COUNT R@ ZPLACE FALSE
   THEN  R> SWAP ;

CoreFoundation.framework

FUNCTION: CFBundleGetMainBundle ( -- CFBundleRef )
FUNCTION: CFBundleCopyBundleURL ( CFBundleRef -- CFURLRef )
FUNCTION: CFBundleCopyExecutableURL ( CFBundleRef -- CFURLRef )
FUNCTION: CFBundleCopyResourcesDirectoryURL ( CFBundleRef -- CFURLRef )
FUNCTION: CFBundleCopySharedSupportURL ( CFBundleRef -- CFURLRef )

: .BUNDLE-INFO ( -- )
   CFBundleGetMainBundle
   DUP CFBundleCopyBundleURL                CR ." Bundle path:         " CFURL> ZCOUNT TYPE
   DUP CFBundleCopyExecutableURL            CR ." Executable path:     " CFURL> ZCOUNT TYPE
   DUP CFBundleCopyResourcesDirectoryURL    CR ." Resource path:       " CFURL> ZCOUNT TYPE
   DUP CFBundleCopySharedSupportURL         CR ." Shared support path: " CFURL> ZCOUNT TYPE
   CFRELEASE DROP ;

CR .( bundlechecker loaded)

\\ ( eof )
