{ ====================================================================
File Manager

Copyright 2014 Roelf Toxopeus

SwiftForth version.
Implements useful file and directory utillites, using NSFileManager.
Last: 13 December 2019 at 08:53:52 CET  -rt
==================================================================== }

{ --------------------------------------------------------------------
(COPY-ITEM) -- expects the source and destination paths as NSString
references. You should reference the item you're copying in the
destination string as well:
 @" ~/Documents/mydoc.txt" @" ~/Desktop/mydoc.txt" (COPY-ITEM)
You don't have to quote paths with spaces, they are recognized allright.
The given NSString refs are not released.

COPY-ITEM differs from (COPY-ITEM): expects zero terminated strings
for source and destination paths. The created NSString refs will be
released.

(MOVE-ITEM) and MOVE-ITEM similar to (COPY-ITEM) and COPY-ITEM respectively,
but moving instead of copying.

RENAME-ITEM -- rename item at path pointed to by zstring a1 with newname
pointed to by zstring a2. A version of MOVE-ITEM.

TRASH-ITEM -- move item at path to the trash. Return the resulting path,
in which the name may be changed because of duplicates in the trash.
Uses NSURL <-> CFURL tollfree bridging.
-------------------------------------------------------------------- }

COCOACLASS NSFileManager
COCOA: @defaultManager ( -- object )
COCOA: @copyItemAtPath:toPath:error: ( NSString:source NSString:destination **error -- boolean )
COCOA: @moveItemAtPath:toPath:error: ( NSString:source NSString:destination **error -- boolean )
COCOA: @localizedDescription ( -- NSStringRef )  \ NSError
COCOA: trashItemAtURL:resultingItemURL:error: ( NSURL:item NSURL:result **error -- boolean )

: ?FILE-ERROR ( error boolean -- )   0= IF @localizedDescription >4THSTRING TYPE ELSE DROP THEN ;
   
: (COPY-ITEM) ( NSString:source NSString:destination -- )
   0 >R RP@ NSFileManager @defaultManager @copyItemAtPath:toPath:error:
   R> SWAP ?FILE-ERROR ;

: COPY-ITEM ( za1 za2 -- )
   >NSSTRING SWAP >NSSTRING SWAP
   2DUP (COPY-ITEM)
   @release DROP @release DROP ;

: (MOVE-ITEM) ( NSString:source NSString:destination -- )
   0 >R RP@ NSFileManager @defaultManager @moveItemAtPath:toPath:error:
   R> SWAP ?FILE-ERROR ;

: MOVE-ITEM ( za1 za2 -- )
   >NSSTRING SWAP >NSSTRING SWAP
   2DUP (MOVE-ITEM)
   @release DROP @release DROP ;

: RENAME-ITEM  ( za1 za2 -- )
   OVER >R ZCOUNT
   R> ZCOUNT -NAME PAD ZPLACE S" /" PAD ZAPPEND
   PAD ZAPPEND
   PAD MOVE-ITEM ;

: TRASH-ITEM ( za1 -- za2 )
   >CFURL DUP ( *) 0 >R RP@ 0 >R RP@
   NSFileManager @defaultManager trashItemAtURL:resultingItemURL:error:
   R> SWAP ?FILE-ERROR
   ( *) CFRelease DROP R> CFURL> ;

\\ ( eof )