{ ====================================================================
Load scrap/paste/clipboard

Copyright 2010 Roelf Toxopeus

SwiftForth version.
Dealing with scrap on the main pasteboard a.k.a. Clipboard
Last: 10 April 2018 at 06:36:24 CEST  -rt
==================================================================== }

{ --------------------------------------------------------------------
For now only looking for text scrap (from editors).

PUT-SCRAP -- paste/put string in clipboard. Returns true if succes.
GET-SCRAP --  copy/get text from clipboard. Returns string pair if succes,
0 0 if not.
EVALUATE-SCRAP -- evaluate a scrap of (mutlti line) text 'addr ucount'.
Uses parts from INCLUDE-FILE. The interpreting loop could be factored
as INTERPRET-MAPPED. Setting 'SOURCE-ID to -2 indicates scrap is source.
LOAD-SCRAP -- include/load contents clipboard.
-------------------------------------------------------------------- }

/FORTH
DECIMAL

COCOACLASS NSPasteboard

COCOA: @generalPasteboard ( -- id ) \ NSPasteboard object
: CLIPBOARD ( -- ref ) NSPasteboard @generalPasteboard ;

GLOBAL: NSPasteboardTypeString  ( text type, in NSPasteboard.h )

COCOA: @clearContents ( -- n )      \ NSInteger
COCOA: @setString:forType: ( string datatype -- flag ) \ NSString object, NSstring object -- BOOL

: PUT-SCRAP ( a n -- bool )
   CLIPBOARD @clearContents DROP
   PAD ZPLACE PAD >NSSTRING DUP >R
   NSPasteboardTypeString @
   CLIPBOARD @setString:forType:
   R> @RELEASE DROP ;

COCOA: @stringForType: ( type -- concatstring ) \ NSString object -- NSString object

: GET-SCRAP ( -- a n | 0 0 )
   NSPasteboardTypeString @
   CLIPBOARD @stringForType:
   DUP IF >4THSTRING  ELSE DUP  THEN ;

\ --------------------------------------------------------------------
\ Include contents clipboard.

: EVALUATE-SCRAP ( a u -- )
   >MAPPED 2!  
   SAVE-INPUT N>R  >IN OFF  LINE OFF
   -2 'SOURCE-ID !
   BEGIN  REFILL-NEXTLINE  WHILE  MONITOR INTERPRET  REPEAT
   NR> RESTORE-INPUT DROP ;

: LOAD-SCRAP ( -- )   GET-SCRAP EVALUATE-SCRAP ;

\\ ( eof )