{ ====================================================================
Extra window utillities.

Copyright 2002 Roelf Toxopeus

Part of GUI stuff.
SwiftForth version.
Last: 29 December 2018 at 14:35:13 CEST  -rt
==================================================================== }

{ --------------------------------------------------------------------
Extra window utils, as used in MacForth.
There is much more you can do, add them when needed.

@MAINSIZE -- return dimensions fullscreen in given rect structure.
FULL.FRAME -- return dimensions fullscreen, uses w.bounds field from
given window.
FULL.SCREEN -- sets given window to full screen.
CONTENT.FRAME -- return dimensions contentview from given window.
CONTENT.SIZE -- return width and height contentview from given window.
MAKE.CONTENTVIEW -- set contentview for window. Main thread execution.

Some background colour presets for window:
DEFAULT.BG BBE.BG WHITE.BG RED.BG BLACK.BG
-------------------------------------------------------------------- }

/FORTH
DECIMAL

COCOACLASS NSScreen
COCOA: @mainScreen ( -- NSScreen:mainscreen )

: @MAINSIZE ( a -- )   NSScreen @mainScreen @frame DROP ;

: FULL.FRAME ( wptr4 -- ) ( F: -- x y w h )   +W.BOUNDS DUP @mainsize CG4@ ;
   
: FULL.SCREEN ( wptr4 -- )   DUP >R FULL.FRAME  R> FIX.WINDOW ;

\ get frame rect contentview
COCOA: @contentView ( -- contentviewref )

: CONTENT.FRAME ( wptr4 -- ) ( F: -- x y w h )
   DUP +W.BOUNDS DUP >R SWAP +W.REF @ @contentView @frame DROP R> CG4@ ;

: CONTENT.SIZE ( wptr4 -- ) ( F: -- width height )
   CONTENT.FRAME F2SWAP FDROP FDROP ;

\ set window contentview
COCOA: @setContentView: ( viewref -- ret )

: MAKE.CONTENTVIEW ( viewref wptr4 -- )
   +W.REF @ >R
   Z" setContentView:" @selector SWAP YES R> FORMAIN DROP ;

(*
: DIMENSIONS ( F: T L B R -- wide high )    ;

: TL.WINDOW ( wptr4 -- ) ( F: -- top left )   ;

: BL.WINDOW ( wptr4 -- ) ( F: -- bottom right )  ;
*)

\ Some colour presets
COCOA: @redColor ( -- red )               \ NSColor object
COCOA: @whiteColor ( -- white )           \ NSColor object
COCOA: @blackColor ( -- black )           \ NSColor object
COCOA: @windowBackgroundColor ( -- ref )  \ macOS default background window color

: DEFAULT.BG ( wptr4 -- )   NSColor @windowBackgroundColor SWAP +W.REF @ @setBackgroundColor: DROP ;

: BBECOLOR ( -- NSColorRef )   \ BBEdit background window color
   248 S>F 255e0 f/
   249 S>F 255e0 f/
   248 S>F 255e0 f/
   255 S>F 255e0 f/
   RGBA>NSCOLOR ;
   
: BBE.BG ( wptr4 -- )   BBECOLOR SWAP +W.REF @ @setBackgroundColor: DROP ;

: WHITE.BG ( wptr4 -- )
   NSColor @whiteColor SWAP +W.REF @ @setBackgroundColor: DROP ;

: RED.BG ( wptr4 -- )
   NSColor @redColor   SWAP +W.REF @ @setBackgroundColor: DROP ;

: BLACK.BG ( wptr4 -- )
   NSColor @blackColor SWAP +W.REF @ @setBackgroundColor: DROP ;

\\ ( eof )