{ ====================================================================
Appearances

Copyright 2018 Roelf Toxopeus

SwiftForth version.
Dark and Light Mode for macOS 10.14 Mojave.
NSApp level only for now.
Last: 29 December 2018 at 22:43:03 CEST   -rt
==================================================================== }

{ --------------------------------------------------------------------
APPEARANCE? -- test for the appearance property in object/instance.

APPEARANCE -- set object/instance to the given named appearance.
macOS versions prior to 10.14 Mojave might ignore this.

DarkMode -- set our NSApp, the Cocoa part of coco-sf, to Dark Mode.
LightMode -- set our NSApp the Cocoa part of coco-sf, to Light Mode.

Windows and views with an 'appearance' property can be individualy set
to whatever named appearances with APPEARANCE.

See:
https://developer.apple.com/documentation/appkit/nsappearance?language=objc
https://developer.apple.com/documentation/appkit/supporting_dark_mode_in_your_interface?language=objc
-------------------------------------------------------------------- }

/FORTH
DECIMAL

FUNCTION: class_getProperty ( class name -- ref )

: APPEARANCE? ( id -- f )    object_getClass  Z" appearance" class_getProperty 0<> ;

COCOACLASS NSAppearance
COCOA: @appearanceNamed: ( NSStringRef -- NSAppearanceRef )

: APPEARANCE ( za id -- )
   DUP APPEARANCE? IF
      >R
      >NSString DUP
      NSAppearance @appearanceNamed:
      Z" setAppearance:" @selector OVER NO R> FORMAIN DROP
      @release DROP @release DROP  ( could be released too soon!)
   ELSE  2DROP THEN ;
   
: DarkMode ( -- )   Z" NSAppearanceNameDarkAqua" NSApp @ APPEARANCE ;

: LightMode ( -- )   Z" NSAppearanceNameAqua" NSApp @ APPEARANCE ;

\\ ( eof)

