{ ====================================================================
simple help

Copyright 2017 Roelf Toxopeus

SwiftForth version.
Example of adding functionality to NSApplication:
a Help function for information on SwiftForth and coco-sf.
Last: 31 December 2018 at 10:21:04 CET   -rt
==================================================================== }

{ --------------------------------------------------------------------
Present simple (textual) help dialog in repl
HELP -- launch manual for SwiftForth or coco-sf, depending on KEY.

HELPME and HELPME2 use the BSD "open" function wrapped in a string
passed to system.

Adding the functionality to NSApplication is simple.
Of course executing (HELP) does the same and without going through
the ObjC Runtime mill.
But this is a demonstration of adding functionality to an ObjC Class ;-)

Similar functionality can be found in the hotcoco sfmenu5.f example
-------------------------------------------------------------------- }

/FORTH
DECIMAL

FUNCTION: system ( addr -- ret )

: HELPME ( -- )
   S\" open \"" PAD ZPLACE
   ROOTPATH COUNT PAD ZAPPEND
   S\" swiftforth/doc/swiftforth-linux-macos.pdf\"" PAD ZAPPEND
   PAD system DROP ;

: HELPME2 ( -- )
   S\" open \"" PAD ZPLACE
   MACPATH COUNT +ROOT PAD ZAPPEND
   S\" doc/readme.pdf\"" PAD ZAPPEND
   PAD system DROP ;

: (HELP) ( -- )
   CR ." Help for:"
   CR ." SwiftForth -- type 1"
   CR ." coco-sf    -- type 2"
   CR ." Key: " KEY DUP PAD C! PAD 1 TYPE
   CASE [CHAR] 1 OF HELPME  ENDOF
        [CHAR] 2 OF HELPME2 ENDOF
        ."  Can't Help ! Try LOCATE or EDIT"
   ENDCASE ;

FORTHCALL: *HELP ( rec sel -- ret )   IMPOSTOR'S  (HELP)  0 ;

*HELP Z" i@:" Z" help" NSApplication ADD.METHOD
 
COCOA: @help ( -- ret )

: HELP ( -- )   NSApp @ @help DROP ;

\\ ( eof)
