{ ====================================================================
Applescript

Copyright 2002 Roelf Toxopeus

SwiftForth version.
Applescripting from within Forth.
Last: 22 June 2020 at 23:34:53 CEST    -rt
==================================================================== }

{ --------------------------------------------------------------------
Applescript scripts need linefeeds to function. You can create scripts
using the escape-character string words or use the multi-line S` word:
mac/utils/string-lines.f

See a simple example at end of file
See GDB.f for example of combining scriptparts into one script.

DOSCRIPT -- execute string as script using NSAppleScript. Returns 0
when error occurs.

See NSAppleScript class documentation for more methods. But those
defined here suffice to make DOSCRIPT.
-------------------------------------------------------------------- }

/FORTH
DECIMAL

COCOACLASS NSAppleScript

COCOA: @initWithSource: ( NSStringRef -- NSAppleScriptRef )
COCOA: @executeAndReturnError: ( NSDictionary -- ret )

: DOSCRIPT ( za -- ret )
   >NSSTRING NSAppleScript @alloc @initWithSource: DUP 0= ABORT" No Script for Source !"
   0 OVER @executeAndReturnError:
   SWAP @release DROP ;   

cr .( applescript interface loaded)

\\ ( eof )

\ --- examples:

: "test" ( -- za )
S` tell application "Terminal"
   activate
   do script with command "ls -al@"
end tell`
   DROP ;

: tt ( -- )   "test" doscript ;

\ alternative without <SCRIPT>
: "test2" ( -- za )
   s\" tell application \"System Preferences\"\l"   pad zplace
   s\" activate\l"                                  pad zappend
   s" end tell"                                     pad zappend
   pad ;

: dd ( -- )   "test2" doscript ;

\ another script
: "s1" ( -- za )
S` tell application "System Preferences"
   activate
   set current pane to pane "com.apple.preferences.users"
end tell`
   DROP ;

: ss ( -- )   "s1" doscript ;

\ very interesting script
\ select and cmd-c -> forth: load-scrap -> xx

: "s2" ( -- za )
S` tell application "Terminal"
   activate
end tell
tell application "System Events"
   tell process "Terminal"
      keystroke (the clipboard as text)
      keystroke return
   end tell
end tell`
   DROP ;

: xx ( -- )  "s2" doscript ;

\ toggle system wide darkmode in macOS 10.14 Mojave

: "s3" ( -- za )
S` tell application "System Events"
    tell appearance preferences
        if dark mode is false then
            set dark mode to true
        else
            set dark mode to false
        end if
    end tell
end tell`
   DROP ;

: ~DM ( -- )  "s3" doscript ;

\\ ( eof )