{ ====================================================================
fp utillities

Copyright 2002 Roelf Toxopeus

SwiftForth version.
Origin MacForth version, which uses PPC instructions.
FP utillities for fp stack juggling and FP parameter passing.
Last: 28 February 2018 at 09:13:49 CEST  rt
==================================================================== }

/FORTH
DECIMAL

{ --------------------------------------------------------------------
fp stack jugglers

Due to the Mac's usage of fp for all graphic related things, fp stack
jugglers similar to those for the data stack are handy.
We deal with fp pairs as used for points, sizes and ranges and fp quads
for rectangles and colours.
F2SWAP F2OVER F2DROP F4DUP FTUCK FNIP do what you expect ...
-------------------------------------------------------------------- }

CODE F2SWAP ( F: r1 r2 r3 r4 -- r3 r4 r1 r2 )
   4 >fs               \ hardwarestack
   ST(2) FXCH            \ r1 r2 r3 r4 -- r1 r4 r3 r2
   ST(1) FXCH            \ r1 r4 r3 r2 -- r1 r4 r2 r3
   ST(3) FXCH            \ r1 r4 r2 r3 -- r3 r4 r2 r1
   ST(1) FXCH            \ r3 r4 r2 r1 -- r3 r4 r1 r2
   4 fs>               \ back to fpstack
   FNEXT

CODE F2OVER ( F: r1 r2 r3 r4 -- r1 r2 r3 r4 r1 r2 )
   4 >fs               \ hardwarestack
   ST(3) FLD            \ r1 r2 r3 r4 -- r1 r2 r3 r4 r1 
   ST(3) FLD            \ r1 r2 r3 r4 r1 -- r1 r2 r3 r4 r1 r2
   6 fs>               \ back to fpstack
   FNEXT

CODE F2DROP ( F: r1 r2 -- )
   2 >fs               \ hardwarestack
   ST(0) FSTP            \ r1 r2 -- r1
   ST(0) FSTP            \ r1 --
   FNEXT
   
CODE F4DUP ( F: r1 r2 r3 r4 -- r1 r2 r3 r4 r1 r2 r3 r4 )
   4 >fs               \ hardwarestack
   ST(3) FLD            \ r1 r2 r3 r4 -- r1 r2 r3 r4 r1 
   ST(3) FLD            \ r1 r2 r3 r4 r1 -- r1 r2 r3 r4 r1 r2
   ST(3) FLD            \ r1 r2 r3 r4 r1 r2 -- r1 r2 r3 r4 r1 r2 r3 
   ST(3) FLD            \ r1 r2 r3 r4 r1 r2 r3 -- r1 r2 r3 r4 r1 r2 r3 r4
   8 fs>               \ back to fpstack
   FNEXT

CODE FTUCK ( F: r1 r2 -- r2 r1 r2 )
   2 >fs               \ hardwarestack
   ST(1) FXCH            \ r1 r2 -- r2 r1 
   ST(1) FLD            \ r2 r1 -- r2 r1 r2
   3 fs>               \ back to fpstack
   FNEXT

CODE FNIP ( F: r1 r2 -- r2 )
   2 >fs               \ hardwarestack
   ST(1) FXCH            \ r1 r2 -- r2 r1
   ST(0) FSTP            \ r2 r1 -- r2
   1 fs>               \ back to fpstack
   FNEXT

(*
CODE F2NIP ( F: r1 r2 r3 r4 -- r3 r4 )
   4 >fs               \ hardwarestack
   ST(2) FXCH            \ r1 r2 r3 r4 -- r1 r4 r3 r2
   ST(0) FSTP           \ r1 r4 r3 r2 -- r1 r4 r3
   ST(2) FXCH            \    r1 r4 r3 -- r3 r4 r1
   ST(0) FSTP           \    r3 r4 r1 -- r3 r4
   2 fs>               \ back to fpstack
   FNEXT
*)
   
CODE -FROT ( F: r1 r2 r3 -- r3 r1 r2 )
   3 >fs               \ hardwarestack
   ST(2) FXCH
   ST(1) FXCH
   3 fs>               \ back to fpstack
   FNEXT

{ --------------------------------------------------------------------
Temporarely store top fp stack on return stack.
Similar rules as >R R> R@
   : ff ( -- )   1234e-2 .s f>r .s rp@ f@ .s fr@ .s fr> .s ;
-------------------------------------------------------------------- }

ICODE F>R ( F: r -- ) ( R: -- r )
   >f
   8 # ESP SUB           
   0 [ESP] QWORD FSTP  
   FNEXT

ICODE FR> ( F: -- r ) ( R: r -- )
   0 [ESP] QWORD FLD
   8 # ESP ADD
   f>
   FNEXT

ICODE FR@ ( F: -- r ) ( R: r -- r )
   0 [ESP] QWORD FLD
   f>
   FNEXT

cr .( fp utilities loaded)

\\ ( eof )

