{ ====================================================================
Inline code for optimizer

Copyright 2001  FORTH, Inc.
Rick VanNorman

These ICODE definitions are in support of the optimizer.
==================================================================== }

PACKAGE OPTIMIZING-COMPILER

ICODE DROP-R> ( n -- x )   ( R: x -- )
   EBX POP
   RET   END-CODE

ICODE DROP-R@ ( n -- x )   ( R: x -- x )
   0 [ESP] EBX MOV
   RET   END-CODE

ICODE >R-OVER ( a b c -- a b a )   ( r: -- c )
   EBX PUSH   CELL [EBP] EBX MOV
   RET   END-CODE

ICODE >R-OVER-R> ( a b c -- a b a c )
   -CELL [EBP] EBP LEA   2 CELLS [EBP] EAX MOV
   EAX 0 [EBP] MOV
   RET   END-CODE

ICODE 2CELLS+ ( a -- a+8 )
   2 CELLS # EBX ADD
   RET   END-CODE

ICODE SWAP-@ ( a x -- x n )
   0 [EBP] EAX MOV   EBX 0 [EBP] MOV
   0 [EAX] EBX MOV
   RET   END-CODE

ICODE SWAP-! ( a n -- )
   0 [EBP] EAX MOV   EBX 0 [EAX] MOV
   CELL [EBP] EBX MOV   2 CELLS [EBP] EBP LEA
   RET   END-CODE

ICODE SWAP-C! ( a c -- )
   0 [EBP] EAX MOV   BL 0 [EAX] MOV
   CELL [EBP] EBX MOV   2 CELLS [EBP] EBP LEA
   RET   END-CODE

ICODE ROT-! ( a x n -- x )
   CELL [EBP] EAX MOV   EBX 0 [EAX] MOV
   0 [EBP] EBX MOV   2 CELLS [EBP] EBP LEA
   RET   END-CODE

ICODE DUP?EXIT ( f -- f )
   EBX EBX OR   0<> IF   RET   THEN
   RET   END-CODE

ICODE DUP-EXIT ( f -- f )
   EBX EBX OR   0= IF   RET   THEN
   RET   END-CODE

ICODE ?DUP?EXIT ( f -- true )   ( f -- )
   EBX EBX OR   0<> IF   RET   THEN
   POP(EBX)   RET   END-CODE

ICODE ?DUP-EXIT
   EBX EBX OR   0= IF   POP(EBX)   RET   THEN
   RET   END-CODE

ICODE ?DUP-IF
   EBX EBX OR   0= IF   POP(EBX)   HERE $400 + JMP   THEN
   RET   END-CODE

ICODE DUP-IF
   EBX EBX OR   HERE $400 + JZ
   RET   END-CODE

ICODE OVER-IF
   0 # 0 [EBP] CMP   HERE $400 + JZ
   RET   END-CODE

ICODE R@-IF ( -- )
   0 # 0 [ESP] CMP   HERE $400 + JZ
   RET   END-CODE

ICODE SWAP->R
   0 [EBP] PUSH   4 # EBP ADD
   RET   END-CODE

ICODE OVER->R
   0 [EBP] PUSH
   RET   END-CODE

ICODE THIRD->R
   CELL [EBP] PUSH
   RET   END-CODE

ICODE ROT->R
   CELL [EBP] PUSH   0 [EBP] EAX MOV
   EAX CELL [EBP] MOV   CELL [EBP] EBP LEA
   RET   END-CODE

ICODE >R-DUP
   EBX PUSH   0 [EBP] EBX MOV
   RET   END-CODE

ICODE DUP-R@
   2 CELLS # EBP SUB   EBX 0 [EBP] MOV
   EBX CELL [EBP] MOV   0 [ESP] EBX MOV
   RET   END-CODE

ICODE @-SWAP
   0 [EBX] EAX MOV   0 [EBP] EBX MOV
   EAX 0 [EBP] MOV
   RET   END-CODE

ICODE OVER-R@
   -2 CELLS [EBP] EBP LEA
   EBX CELL [EBP] MOV   2 CELLS [EBP] EAX MOV
   EAX 0 [EBP] MOV   0 [ESP] EBX MOV
   RET   END-CODE

ICODE DOES>-SWAP
   -CELL [EBP] EBP LEA   0 [EBP] POP
   RET   END-CODE

ICODE ROT-2DROP
   0 [EBP] EBX MOV   2 CELLS [EBP] EBP LEA
   RET   END-CODE

ICODE -ROT-2DROP
   2 CELLS [EBP] EBP LEA
   RET   END-CODE

ICODE @+-+
   0 [EBX] EAX MOV   CELL [EBX] [EAX] EBX LEA
   RET   END-CODE

ICODE @IF
   0 [EBX] EAX MOV   0 [EBP] EBX MOV
   CELL [EBP] EBP LEA   EAX EAX OR   HERE $400 + JZ
   RET   END-CODE

ICODE C@IF
   0 [EBX] AL MOV   0 [EBP] EBX MOV
   CELL [EBP] EBP LEA   AL AL OR   HERE $400 + JZ
   RET   END-CODE

ICODE DROP-OVER
   CELL [EBP] EBX MOV
   RET   END-CODE

ICODE DROP-DUP
   0 [EBP] EBX MOV
   RET   END-CODE

ICODE COUNT-+
   EAX EAX XOR   0 [EBX] AL MOV   1 [EBX] [EAX] EBX LEA
   RET   END-CODE

ICODE !-R>
   0 [EBP] EAX MOV   EAX 0 [EBX] MOV
   EBX POP   CELL [EBP] EBP LEA
   RET   END-CODE

ICODE DUP-@
   PUSH(EBX)   0 [EBX] EBX MOV
   RET   END-CODE

ICODE R@-SWAP
   -CELL [EBP] EBP LEA   0 [ESP] EAX MOV   EAX 0 [EBP] MOV
   RET   END-CODE

ICODE TUCK! ( n a -- a )
   0 [EBP] EAX MOV   EAX 0 [EBX] MOV   CELL [EBP] EBP LEA
   RET   END-CODE

ICODE CELL+@ ( a -- n )
   CELL [EBX] EBX MOV
   RET   END-CODE

ICODE CELL+_! ( n a -- )
   0 [EBP] EAX MOV   EAX CELL [EBX] MOV
   CELL [EBP] EBX MOV   2 CELLS [EBP] EBP LEA
   RET   END-CODE

ICODE I@ ( -- n )
   -CELL [EBP] EBP LEA   EBX 0 [EBP] MOV
   0 [ESP] EAX MOV   CELL [ESP] EAX ADD
   0 [EAX] EBX MOV
   RET   END-CODE

ICODE IC@ ( -- n )
   -CELL [EBP] EBP LEA   EBX 0 [EBP] MOV
   EBX EBX XOR   0 [ESP] EAX MOV
   CELL [ESP] EAX ADD   0 [EAX] BL MOV
   RET   END-CODE

ICODE UNDER ( a b -- a a b )
   0 [EBP] EAX MOV   -CELL [EBP] EBP LEA   EAX 0 [EBP] MOV
   RET   END-CODE

ICODE 2@SWAP ( a -- hi lo )
   -CELL [EBP] EBP LEA   0 [EBX] EAX MOV
   CELL [EBX] EBX MOV   EAX 0 [EBP] MOV
   RET   END-CODE

ICODE 2DUP-SWAP ( a b -- a b b a )
   -2 CELLS [EBP] EBP LEA   EBX CELL [EBP] MOV
   EBX 0 [EBP] MOV   2 CELLS [EBP] EBX MOV
   RET   END-CODE

ICODE NIPNIP ( a b c -- c )
   2 CELLS [EBP] EBP LEA
   RET   END-CODE

PUBLIC

ICODE 4DROP ( x1 x2 x3 x4 -- )
   3 CELLS [EBP] EBX MOV   4 CELLS [EBP] EBP LEA
   RET   END-CODE

ICODE R++ ( R: x1 -- x2 )
   1 # 0 [ESP] ADD   RET   END-CODE

END-PACKAGE
