{ ====================================================================
Structures

Copyright 2021 by FORTH, Inc.

This implements structures from the Forth-2012 optional Facility Word Set.

==================================================================== }

{ --------------------------------------------------------------------
<Subtitle>

BEGIN-STRUCTURE Skip leading space delimiters. Parse name delimited by
a space. Create a definition for name with the execution semantics
defined below. Return a struct-sys (zero or more implementation
dependent items) that will be used by END-STRUCTURE and an initial
offset of 0.

END-STRUCTURE Terminate definition of a structure started by
BEGIN-STRUCTURE.

+FIELD Skip leading space delimiters. Parse name delimited by a space.
Create a definition for name with the execution semantics defined
below. Return n3 = n1 + n2 where n1 is the offset in the data
structure before +FIELD executes, and n2 is the size of the data to be
added to the data structure. n1 and n2 are in address units.

CFIELD: makes a character field.
FIELD: makes an aligned cell field.
-------------------------------------------------------------------- }

: BEGIN-STRUCTURE ( "<spaces>name" -- addr 0 )
   CREATE  HERE 0 , 0
   DOES> ( -- +n ) @ ;

: END-STRUCTURE ( addr +n -- )
   OVER @ 0<>  OVER 0< OR ABORT" Invalid structure"
   SWAP ! ;

: +FIELD ( n1 n2 "<spaces>name" -- n3 )
   CREATE  OVER , +
   DOES> ( addr1 -- addr2 )  @ + ;

: CFIELD: ( n1 "<spaces>name" -- n2 )
   1 +FIELD ;

: FIELD: ( n1 "<spaces>name" -- n2 )
   ALIGNED  CELL +FIELD ;
