{ ====================================================================
Loader structures, 32-bit

Copyright 2020 by FORTH, Inc.

These structures are based on the macOS loader.h headers.
==================================================================== }

PACKAGE PROGRAM-GENERATOR

$FEEDFACE CONSTANT MH_MAGIC     \ Mach-o file header magic number (32-bit)

{ --------------------------------------------------------------------
Mach-o loader segment struct

The SET method sets the base address for the structure in memory.
-------------------------------------------------------------------- }

LOADER SUBCLASS SEGMENT                 \ for 32-bit architectures
        0
        4 FIELD:        cmd             \ LC_SEGMENT
        4 FIELD:        cmdsize         \ includes sizeof section structs
        16 FIELD:       segname         \ segment name
        4 FIELD:        vmaddr          \ memory address of this segment
        4 FIELD:        vmsize          \ memory size of this segment
        4 FIELD:        fileoff         \ file offset of this segment
        4 FIELD:        filesize        \ amount to map from the file
        4 FIELD:        maxprot         \ maximum VM protection
        4 FIELD:        initprot        \ initial VM protection
        4 FIELD:        nsects          \ number of sections in segment
        4 FIELD:        flags           \ flags
        DROP

: SET ( addr -- )             \ addr = address of segname field
   segname cmd - - SET ;

END-CLASS

{ --------------------------------------------------------------------
Mach-o loader section struct
-------------------------------------------------------------------- }

LOADER SUBCLASS SECTION                 \ for 32-bit architectures
        0
        16 FIELD:      sectname         \ name of this section */
        16 FIELD:      segname          \ segment this section goes in */
        4 FIELD:       addr             \ memory address of this section
        4 FIELD:       size             \ size in bytes of this section
        4 FIELD:       offset           \ file offset of this section
        4 FIELD:       align            \ section alignment (power of 2)
        4 FIELD:       reloff           \ file offset of relocation entries
        4 FIELD:       nreloc           \ number of relocation entries
        4 FIELD:       flags            \ flags (section type and attributes)
        4 FIELD:       reserved1        \ reserved (for offset or index)
        4 FIELD:       reserved2        \ reserved (for count or sizeof)
        DROP

END-CLASS

END-PACKAGE
