{ ====================================================================
Callbacks

Copyright 2001  FORTH, Inc.
Rick VanNorman

CALLBACK: defines entry points into the Forth environment that can be
called by the OS or and external library or program.
==================================================================== }

?( Windows Callbacks)

/FORTH

{ ------------------------------------------------------------------------
Caught errors

CAUGHT is passed the ior returned by CATCH for additional handling by the
system. The exception dialog box is set as the CAUGHT behavior by default
(see exception-dialog.f for details) but an application may instead
choose to do something else (e.g. log the exception details to a file).
------------------------------------------------------------------------ }

DEFER CAUGHT ( ior -- )   ' DROP IS CAUGHT

PACKAGE WINDOWS-INTERFACE

{ ------------------------------------------------------------------------
Callback code

Preserve: EDI, ESI, EBX, EBP
------------------------------------------------------------------------ }

: CALLBACK ( xt -- res )
   CATCH ?DUP IF  CAUGHT 0  THEN ;

LABEL RUNCB
   2 CELLS [ESP] ECX LEA                \ ECX points to parameters
   0 [ESP] EDX MOV                      \ Return addr in CALLBACK: word's parameter field

   EBX PUSH                             \ Save registers
   ESI PUSH
   EDI PUSH
   EBP PUSH

   -4 CELLS [ESP] EBP LEA               \ start stack in open space
   $1000 # ESP SUB                      \ move return stack below
   2 CELLS [ESP] ESI LEA                \ user area above stack
   ECX 'WF [U] MOV                      \ set callback parameter pointer
   ESP R0 [U] MOV                       \ save stack pointers in user area
   EBP S0 [U] MOV

   |CB-USER| [ESI] EAX LEA              \ generate a new dictionary pointer
   EAX H [U] MOV                        \ and set into user area
   |CB-USER| $400 + [ESI] EAX LEA       \ top of dictionary =  here + 1k available
   EAX HLIM [U] MOV                     \ and top of dictionary

   $0A # BASE [U] MOV                   \ decimal
   0 # 'METHOD [U] MOV                  \ default method
   0 # STATE [U] MOV                    \ not compiling

   BEGIN 5 + DUP CALL   EDI POP         \ establish data space pointer in EDI
   ( *) -ORIGIN # EDI SUB

   0 # 0 [EBP] MOV                      \ nos=zero
   CELL [EDX] EBX MOV                      \ get xt for tos
   ' CALLBACK >CODE CALL                \ and run the word...
   EBX EAX MOV                          \ return result

   S0 [U] ESP MOV                       \ restore
   4 CELLS # ESP ADD                    \ and negate the padding
   EBP POP                              \ restore registers
   EDI POP
   ESI POP
   EBX POP
   RET   END-CODE

PUBLIC

: CALLBACK: ( xt n -- )  \ Usage: xt n CALLBACK: <name>
   CREATE  RUNCB ,CALL  ( nRET) $C2 C, CELLS W,
   ( Filler) 0 C,  ( xt) , ;

: CB: ( xt n -- )   CALLBACK: ;         \ Legacy compatibility

END-PACKAGE
