{ ====================================================================
SwiftForth electives

Copyright 2001 FORTH, Inc.

This file extends the SwiftForth kernel environment.

Requires SwiftForth 3.10.0 or later
==================================================================== }

INCLUDE %SwiftForth\src\ide\errmessages                 \ The basis for error handling
INCLUDE %SwiftForth\src\ide\encapsulate                 \ Simple vocabulary management
INCLUDE %SwiftForth\src\ide\asm-i386                    \ The opcode assembler
INCLUDE %SwiftForth\src\ide\assembler                   \ Assembler access
INCLUDE %SwiftForth\src\ide\preamble                    \ Common support
INCLUDE %SwiftForth\src\ide\optimizer                   \ Optimizing compiler
INCLUDE %SwiftForth\src\ide\inlines                     \ Inline expansions of common phrases
INCLUDE %SwiftForth\src\ide\patterns                    \ Patterns of xts to be optimized
INCLUDE %SwiftForth\src\ide\swoopopt                    \ Optimization for swoop
/OPTIMIZER                                              \ Initialize code optimizer

INCLUDE %SwiftForth\src\ide\win32\preamble              \ Win32 support
INCLUDE %SwiftForth\src\ide\tools                       \ Programmer tools
INCLUDE %SwiftForth\src\ide\struct                      \ Standard Forth structures
INCLUDE %SwiftForth\src\ide\prune                       \ Dictionary management
INCLUDE %SwiftForth\src\ide\aswoop                      \ Object oriented programming
INCLUDE %SwiftForth\src\ide\localvariables              \ Variables and objects on the return stack
INCLUDE %SwiftForth\src\ide\buffio                      \ Buffered io personality
INCLUDE %SwiftForth\src\ide\decode                      \ Disassembler/decompiler
INCLUDE %SwiftForth\src\ide\traverse                    \ Traverse wordlists
INCLUDE %SwiftForth\src\ide\strings                     \ Extended string functions
INCLUDE %SwiftForth\src\ide\values                      \ Value OOP extension
INCLUDE %SwiftForth\src\ide\fileviewer                  \ View lines of a file
INCLUDE %SwiftForth\src\ide\locate                      \ Locate source code
INCLUDE %SwiftForth\src\ide\vocabularies                \ Vocabularies, wordlist management
INCLUDE %SwiftForth\src\ide\words                       \ Dictionary visibility
INCLUDE %SwiftForth\src\ide\win32\xref                  \ Cross reference support
INCLUDE %SwiftForth\src\ide\xref                        \ Cross reference utility
INCLUDE %SwiftForth\src\ide\win32\imports               \ Import functions from external libraries
INCLUDE %SwiftForth\src\ide\win32\winconstants          \ Common windows constants
INCLUDE %SwiftForth\src\ide\win32\dllfunctions          \ Windows API calls
INCLUDE %SwiftForth\src\ide\win32\callback              \ Windows callback handler
INCLUDE %SwiftForth\src\ide\win32\exception-map         \ Exception context register map
INCLUDE %SwiftForth\src\ide\exception                   \ Exception context debug display
INCLUDE %SwiftForth\src\ide\win32\winstructures         \ Windows data structures
INCLUDE %SwiftForth\src\ide\win32\registry              \ Read and write windows registry
INCLUDE %SwiftForth\src\ide\win32\configuration         \ System configuration kept in registry
INCLUDE %SwiftForth\src\ide\win32\tasking               \ Multi-threaded multitasking
INCLUDE %SwiftForth\src\ide\tasking                     \ Common multitasking
INCLUDE %SwiftForth\src\ide\win32\calendar              \ Date/time
INCLUDE %SwiftForth\src\ide\win32\counter               \ Elapsed time measurements
INCLUDE %SwiftForth\src\ide\loader                      \ Loader tools
INCLUDE %SwiftForth\src\ide\win32\loader                \ PE loader structures
INCLUDE %SwiftForth\src\ide\win32\save                  \ Save turnkey image
INCLUDE %SwiftForth\src\ide\win32\directory             \ Generate directory listings
INCLUDE %SwiftForth\src\ide\win32\shell                 \ Shell interface; run programs etc
INCLUDE %SwiftForth\src\ide\win32\notepad               \ Interface to windows notepad for editor
INCLUDE %SwiftForth\src\ide\win32\editor                \ Interface to arbitrary external editor
INCLUDE %SwiftForth\src\ide\win32\editline              \ Supercharge ACCEPT; history and command completion
INCLUDE %SwiftForth\src\ide\win32\requires              \ Optional package loading in LIB\
INCLUDE %SwiftForth\src\ide\options                     \ Optional packages; load only once
INCLUDE startup                                         \ Program starup

-? : HI ( ---)   ." Already loaded" ;

ONLY FORTH DEFINITIONS  GILD

OBSCURED @ [IF]

BRIGHT
CR OBSCURED ? .( definitions were hidden, no program saved.) CR
NORMAL
QUIT
[THEN]

PROGRAM %SwiftForth\bin\sf-cli.exe
RESTORE-CONFIGURATION
BYE
