{ ====================================================================
Exception handler context interpreter

Copyright 2020  FORTH, Inc.

This file defines the register offsets in the machine context record
captured by the vectored exception handler.
==================================================================== }

PACKAGE ERROR-HANDLERS

{ --------------------------------------------------------------------
Registers

The ENUMs below define the order of the registers at the beginning of
the TRACEBACK buffer.
-------------------------------------------------------------------- }

0
ENUM REG_GS
ENUM REG_FS
ENUM REG_ES
ENUM REG_DS
ENUM REG_EDI
ENUM REG_ESI
ENUM REG_EBX
ENUM REG_EDX
ENUM REG_ECX
ENUM REG_EAX
ENUM REG_EBP
ENUM REG_EIP
ENUM REG_CS
ENUM REG_EFL
ENUM REG_ESP
ENUM REG_SS
DROP

{ --------------------------------------------------------------------
Decode Windows exceptions

The exception-type switch is a mechanism to produce a printable
string for the standard windows exceptions that we can catch.
Unknown values produce a hex representation of the ior.
-------------------------------------------------------------------- }

[SWITCH EXCEPTION-TYPE (H.8)    ( ior -- addr n )
   STATUS_WAIT_0                   RUN: S" WAIT_0"                    ;
   STATUS_ABANDONED_WAIT_0         RUN: S" ABANDONED_WAIT_0"          ;
   STATUS_USER_APC                 RUN: S" USER_APC"                  ;
   STATUS_TIMEOUT                  RUN: S" TIMEOUT"                   ;
   STATUS_PENDING                  RUN: S" PENDING"                   ;
   STATUS_DATATYPE_MISALIGNMENT    RUN: S" DATATYPE_MISALIGNMENT"     ;
   STATUS_BREAKPOINT               RUN: S" BREAKPOINT"                ;
   STATUS_SINGLE_STEP              RUN: S" SINGLE_STEP"               ;
   STATUS_ACCESS_VIOLATION         RUN: S" ACCESS_VIOLATION"          ;
   STATUS_IN_PAGE_ERROR            RUN: S" IN_PAGE_ERROR"             ;
   STATUS_NO_MEMORY                RUN: S" NO_MEMORY"                 ;
   STATUS_ILLEGAL_INSTRUCTION      RUN: S" ILLEGAL_INSTRUCTION"       ;
   STATUS_NONCONTINUABLE_EXCEPTION RUN: S" NONCONTINUABLE_EXCEPTION"  ;
   STATUS_INVALID_DISPOSITION      RUN: S" INVALID_DISPOSITION"       ;
   STATUS_ARRAY_BOUNDS_EXCEEDED    RUN: S" ARRAY_BOUNDS_EXCEEDED"     ;
   STATUS_FLOAT_DENORMAL_OPERAND   RUN: S" FLOAT_DENORMAL_OPERAND"    ;
   STATUS_FLOAT_DIVIDE_BY_ZERO     RUN: S" FLOAT_DIVIDE_BY_ZERO"      ;
   STATUS_FLOAT_INEXACT_RESULT     RUN: S" FLOAT_INEXACT_RESULT"      ;
   STATUS_FLOAT_INVALID_OPERATION  RUN: S" FLOAT_INVALID_OPERATION"   ;
   STATUS_FLOAT_OVERFLOW           RUN: S" FLOAT_OVERFLOW"            ;
   STATUS_FLOAT_STACK_CHECK        RUN: S" FLOAT_STACK_CHECK"         ;
   STATUS_FLOAT_UNDERFLOW          RUN: S" FLOAT_UNDERFLOW"           ;
   STATUS_INTEGER_DIVIDE_BY_ZERO   RUN: S" INTEGER_DIVIDE_BY_ZERO"    ;
   STATUS_INTEGER_OVERFLOW         RUN: S" INTEGER_OVERFLOW"          ;
   STATUS_PRIVILEGED_INSTRUCTION   RUN: S" PRIVILEGED_INSTRUCTION"    ;
   STATUS_STACK_OVERFLOW           RUN: S" STACK_OVERFLOW"            ;
   STATUS_CONTROL_C_EXIT           RUN: S" CONTROL_C_EXIT"            ;
SWITCH]

END-PACKAGE
