{ ====================================================================
Loader structures, 32-bit

Copyright 2020 by FORTH, Inc.

These structures are based on the winnt.h headers.
==================================================================== }

PACKAGE PROGRAM-GENERATOR

{ --------------------------------------------------------------------
PE header
-------------------------------------------------------------------- }

LOADER SUBCLASS IMAGE_NT_HEADERS        \ for 32-bit architectures
        0
        4 FIELD:        Signature       \ 'P', 'E', 0, 0
        2 FIELD:        Machine
        2 FIELD:        NumberOfSections
        4 FIELD:        TimeDateStamp
        4 FIELD:        PointerToSymbolTable
        4 FIELD:        NumberOfSymbols
        2 FIELD:        SizeOfOptionalHeader
        2 FIELD:        Characteristics
        2 FIELD:        Magic
        1 FIELD:        MajorLinkerVersion
        1 FIELD:        MinorLinkerVersion
        4 FIELD:        SizeOfCode
        4 FIELD:        SizeOfInitializedData
        4 FIELD:        SizeOfUninitializedData
        4 FIELD:        AddressOfEntryPoint
        4 FIELD:        BaseOfCode
        4 FIELD:        BaseOfData
        4 FIELD:        ImageBase
        4 FIELD:        SectionAlignment
        4 FIELD:        FileAlignment
        2 FIELD:        MajorOperatingSystemVersion
        2 FIELD:        MinorOperatingSystemVersion
        2 FIELD:        MajorImageVersion
        2 FIELD:        MinorImageVersion
        2 FIELD:        MajorSubsystemVersion
        2 FIELD:        MinorSubsystemVersion
        4 FIELD:        Win32VersionValue
        4 FIELD:        SizeOfImage
        4 FIELD:        SizeOfHeaders
        4 FIELD:        CheckSum
        2 FIELD:        Subsystem
        2 FIELD:        DllCharacteristics
        4 FIELD:        SizeOfStackReserve
        4 FIELD:        SizeOfStackCommit
        4 FIELD:        SizeOfHeapReserve
        4 FIELD:        SizeOfHeapCommit
        4 FIELD:        LoaderFlags
        4 FIELD:        NumberOfRvaAndSizes
        4 FIELD:        DataDirectoryVirtualAddress0
        4 FIELD:        DataDirectorySize0
        DROP

END-CLASS

{ --------------------------------------------------------------------
Section header
-------------------------------------------------------------------- }

LOADER SUBCLASS IMAGE_SECTION_HEADER
        0
        8 FIELD:        Name
        4 FIELD:        VirtualSize
        4 FIELD:        VirtualAddress
        4 FIELD:        SizeOfRawData
        4 FIELD:        PointerToRawData
        4 FIELD:        PointerToRelocations
        4 FIELD:        PointerToLinenumbers
        2 FIELD:        NumberOfRelocations
        2 FIELD:        NumberOfLinenumbers
        4 FIELD:        Characteristics
        DROP

END-CLASS

{ --------------------------------------------------------------------
Image resource data entry

Leaf nodes in the resource directory point to these
IMAGE_RESOURCE_DATA_ENTRY structures.
-------------------------------------------------------------------- }

LOADER SUBCLASS IMAGE_RESOURCE_DATA_ENTRY
        0
        4 FIELD:        OffsetToData    \ Virtual addr
        4 FIELD:        Size
        4 FIELD:        CodePage
        4 FIELD:        Reserved
        DROP

END-CLASS

{ --------------------------------------------------------------------
Group icon directory

GRPICONDIR Contains information about all the icon images contained
within a RT_GROUP_ICON resource in an .exe or .dll.

GRPICONDIRENTRY (nested within GRPICONDIR) contains meta data for a
single icon image within a RT_GROUP_ICON resource in an .exe or .dll.
-------------------------------------------------------------------- }

LOADER SUBCLASS GRPICONDIR
        0
        2 FIELD:        idReserved
        2 FIELD:        idType
        2 FIELD:        idCount

        \ GRPICONDIRENTRY
        1 FIELD:        bWidth
        1 FIELD:        bHeight
        1 FIELD:        bColorCount
        1 FIELD:        bReserved
        2 FIELD:        wPlanes
        2 FIELD:        wBitCount
        4 FIELD:        dwBytesInRes;
        2 FIELD:        nID
        CONSTANT |GRP|

: SET ( addr1 addr2 -- )        \ addr1=ICO header data; addr2=structure addr in memory
   DUP SET  |GRP| CMOVE  1 nID W! ;

END-CLASS

END-PACKAGE
