{ ====================================================================
Target kernel configuration

Copyright 2007  FORTH, Inc.

This file defines the system configuration and declares a code section
for the kernel image to be compiled into.
==================================================================== }

TARGET

{ --------------------------------------------------------------------
System Memory allocation

PROG is the target compiler's code section.  The first two cells of the
image are reserved for use by the SwiftForth loader:

+0  Offset to the SwiftForth program's entry point (set at the end of app.f)
+4  Address of the imported library function jmp table (set by the loader)

The rest of the equates here configure the target kernel.
-------------------------------------------------------------------- }

0 $1FFFF IMAGE                  \ Program is compiled relative to 0
2 CELLS ALLOT                   \ Reserve SwiftForth header cells

10 EQU |FPITEM|                 \ Size of one floating-point stack item
32 EQU #NS                      \ Number of items reserved for floating-point (numeric) stack
#NS |FPITEM| * EQU |FPSTACK|    \ Total floating-point stack size

$1000000 EQU |RAM|              \ Total size allocted in loader
$2000 EQU |USER|                \ Size of user area
$0100 EQU |TIB|                 \ Size of text input buffer
$0400 EQU |QBUF|                \ Size of string buffer
$0200 EQU |NUM|                 \ Size numeric output string buffer (below PAD)
$7F EQU <BS>                    \ Console backspace character
260 EQU MAX_PATH                \ Max path length for R-BUF

{ --------------------------------------------------------------------
Target system dictionary threads

#VOCS is the maximum vocabularies in the search order CONTEXT .

#STRANDS is the default number of strands in a vocabulary and should
be a prime number.  The trade off is space vs speed. Each thread
consumes one cell.

      1 EQU =STRANDS  \ 17.0          ( relative speed of compilation)
      3 EQU =STRANDS  \  4.6
      5 EQU =STRANDS  \  3.6
      7 EQU =STRANDS  \  3.1
     11 EQU =STRANDS  \  2.6
     13 EQU =STRANDS  \  2.4
     17 EQU =STRANDS  \  2.2
     31 EQU =STRANDS  \  2.1
     61 EQU =STRANDS  \  2.0
    127 EQU =STRANDS  \  1.9
    257 EQU =STRANDS  \  1.9
    499 EQU =STRANDS  \  1.8
   4099 EQU =STRANDS  \  1.8
-------------------------------------------------------------------- }

16 EQU =VOCS            \ vocabulary stack depth
127 EQU =STRANDS        \ number of strands in FORTH-WORDLIST
=STRANDS >STRANDS       \ Set target compiler's STRANDS
