{ ====================================================================
Import library functions

Copyright 2009  FORTH, Inc.

The calling of external library functions is implemented here.
Do not make these FUNCTION: words headless.
======================================================================

LIBRARY parameter field:  | handle | flag |
IMPORT: parameter field:  | proc addr | #params | ^lib |
==================================================================== }

TARGET

LIBRARY libc.so.6

{ --------------------------------------------------------------------
SwiftForth's loader includes automatic resolution for the basic set of
library calls (pointed to by ORIGIN CELL+ ) in this table in the
loader source:
        jmp [dlopen]
        jmp [dlclose]
        jmp [dlsym]
        jmp [dlerror]
-------------------------------------------------------------------- }

FUNCTION: sys_dlopen ( *path mode -- h )
FUNCTION: DLCLOSE ( h -- ior )
FUNCTION: DLSYM ( h *sym -- addr )
FUNCTION: DLERROR ( -- zaddr )

0 IMPORTS !

| : /HEADER-IMPORTS ( -- )
   ORIGIN CELL+ @
   DUP ['] sys_dlopen   >BODY !  6 +
   DUP ['] dlclose      >BODY !  6 +
   DUP ['] dlsym        >BODY !  6 +
   DUP ['] dlerror      >BODY !  DROP ;

: DLOPEN ( *path -- h )   1 sys_dlopen ;

{ --------------------------------------------------------------------
The rest of these are resolved by /KERNEL-IMPORTS below.
-------------------------------------------------------------------- }

GLOBAL: errno ( -- addr )

AS sys_exit     FUNCTION: exit ( status -- )
AS sys_unlink   FUNCTION: unlink ( *pathname -- n )
AS sys_free     FUNCTION: free ( addr -- x )

FUNCTION: rename ( oldpath newpath -- n )
FUNCTION: fsync ( fd -- n )
FUNCTION: ftruncate64 ( fd len_h len_l -- n )
FUNCTION: getcwd ( buf maxlen -- addr )
FUNCTION: malloc ( u -- addr )
FUNCTION: realloc ( addr1 u -- addr2 )
FUNCTION: mmap ( start length prot flags fd offset -- addr )
FUNCTION: munmap ( start length -- n )
FUNCTION: ioctl ( fd request param -- n )
FUNCTION: open ( pathname flags mode -- fd )
FUNCTION: close ( fd -- n )
FUNCTION: write ( fd buf count -- n )
FUNCTION: read ( fd buf count -- n )
FUNCTION: poll ( fds nfds timeout -- n )
FUNCTION: sigaction ( signum sigaction oldaction -- n )
FUNCTION: readlink ( path buf bufsiz -- n )
FUNCTION: lseek ( fd offset whence -- n )
FUNCTION: realpath ( addr1 addr2 -- x )

FUNCTION: __xstat ( vers name buf -- n )
FUNCTION: __fxstat64 ( vers fd buf -- n )

: stat ( name buf -- n )   3 -ROT __xstat ;
: fstat ( fd buf -- n )   3 -ROT __fxstat64 ;

$10 CONSTANT FILE_TYPE    \ Offset into stat struct

| : (OPEN-LIBS) ( addr -- )
   DUP @ IF  DUP @REL RECURSE  THEN
   L>NAME  DUP N>BODY  SWAP 1+ DLOPEN SWAP ! ;

| : OPEN-LIBS ( -- )
   LIBS WID> CELL+ @REL (OPEN-LIBS) ;

| : RESOLVE-PROCS ( -- )
   IMPORTS BEGIN                        \ link
      @REL ?DUP WHILE                   \ link
      DUP CELL+ @REL                    \ link nfa
      DUP N>BODY                        \ link nfa pfa
      DUP CELL+ CELL+ @REL @            \ link nfa pfa libh
      ROT 1+ DLSYM                      \ link pfa procaddr
      SWAP !
   REPEAT ;

| : /KERNEL-IMPORTS ( -- )
   /HEADER-IMPORTS  OPEN-LIBS  RESOLVE-PROCS ;
