{ ====================================================================
External library call

Copyright 2009  FORTH, Inc.

The calling of external library functions is implemented here.
This is specific to MACOS.

======================================================================

When we call an external library function, we move the parameters from
the Forth data stack (pointed to by EPB) to the system stack (pointed
to by ESP).  We call all external library functions that we have
addresses of via the EXTERN-CALL routine, which handles the details of
building the stack frame for external procedure call.
==================================================================== }

CODE EXTERN-CALL ( x1 x2 .. xn n a -- x )
   EDI PUSH   ESI PUSH          \ save Forth VM context
   0 [EBP] ECX MOV              \ n args
   ESP EDX MOV                  \ save ESP before building stack frame
   $FFFFFFF0 # ESP AND          \ align SP to mod 16
   ECXNZ IF                     \ skip building stack frame if no args
      ECX EAX MOV   EAX NEG
      3 # EAX AND   EAX NEG
      0 [ESP] [EAX*4] ESP LEA
      BEGIN
         4 [EBP] PUSH           \ move args from data stack to system stack
         4 # EBP ADD
   LOOP THEN
   EDX 0 [EBP] MOV              \ preserve ESP for return
   EBX CALL                     \ call extern function
   EAX EBX MOV                  \ return value
   0 [EBP] ESP MOV              \ restore ESP
   4 # EBP ADD
   ESI POP   EDI POP            \ restore Forth VM
   RET   END-CODE
