{ ====================================================================
Import library functions

Copyright 2009  FORTH, Inc.

The calling of external library functions is implemented here.
Do not make these FUNCTION: words headless.
======================================================================

LIBRARY parameter field:  | handle | flag |
IMPORT: parameter field:  | proc addr | #params | ^lib |
==================================================================== }

TARGET

LIBRARY libc.dylib

{ --------------------------------------------------------------------
SwiftForth's loader includes automatic resolution for the basic set of
library calls in this table in the loader source:
        jmp _exit
        jmp _dlopen
        jmp _dlclose
        jmp _dlsym
        jmp _dlerror
        jmp __NSGetExecutablePath
-------------------------------------------------------------------- }

FUNCTION: sys_exit ( ret -- )
FUNCTION: sys_dlopen ( *path mode -- h )
FUNCTION: DLCLOSE ( h -- ior )
FUNCTION: DLSYM ( h *sym -- addr )
FUNCTION: DLERROR ( -- zaddr )
FUNCTION: getexecpath ( addr1 addr2 -- ior )

0 IMPORTS !

| : /HEADER-IMPORTS ( -- )   ORIGIN CELL+ @
   DUP ['] sys_exit     >BODY !  5 +
   DUP ['] sys_dlopen   >BODY !  5 +
   DUP ['] dlclose      >BODY !  5 +
   DUP ['] dlsym        >BODY !  5 +
   DUP ['] dlerror      >BODY !  5 +
   DUP ['] getexecpath  >BODY !  DROP ;

: DLOPEN ( *path -- h )   1 sys_dlopen ;

{ --------------------------------------------------------------------
The rest of these are resolved by /KERNEL-IMPORTS below.
-------------------------------------------------------------------- }

GLOBAL: errno ( -- addr )

AS sys_unlink   FUNCTION: unlink ( *pathname -- n )
AS sys_free     FUNCTION: free ( addr -- x )

FUNCTION: rename ( oldpath newpath -- n )
FUNCTION: fsync ( fd -- n )
FUNCTION: ftruncate ( fd len_l len_h -- n )
FUNCTION: getcwd ( buf maxlen -- addr )
FUNCTION: malloc ( u -- addr )
FUNCTION: realloc ( addr1 u -- addr2 )
FUNCTION: mmap ( start length prot flags fd ol oh -- addr )
FUNCTION: munmap ( start length -- n )
FUNCTION: ioctl ( fd request param -- n )
FUNCTION: open ( pathname flags mode -- fd )
FUNCTION: close ( fd -- n )
FUNCTION: write ( fd buf count -- n )
FUNCTION: read ( fd buf count -- n )
FUNCTION: poll ( fds nfds timeout -- n )
FUNCTION: sigaction ( signum sigaction oldaction -- n )
FUNCTION: readlink ( path buf bufsiz -- n )
FUNCTION: lseek ( fd offs_l offs_h whence -- n )
FUNCTION: realpath ( addr1 addr2 -- x )

FUNCTION: stat ( path buf -- n )
FUNCTION: fstat ( fd buf -- n )
8 CONSTANT FILE_TYPE    \ Offset into stat struct

FUNCTION: tcgetattr ( fd addr -- n )
FUNCTION: tcsetattr ( fd x addr -- n )

| : (OPEN-LIBS) ( addr -- )
   DUP @ IF  DUP @REL RECURSE  THEN
   L>NAME  DUP N>BODY  SWAP 1+ DLOPEN SWAP ! ;

| : OPEN-LIBS ( -- )
   LIBS WID> CELL+ @REL (OPEN-LIBS) ;

| : RESOLVE-PROCS ( -- )
   IMPORTS BEGIN                        \ link
      @REL ?DUP WHILE                   \ link
      DUP CELL+ @REL                    \ link nfa
      DUP N>BODY                        \ link nfa pfa
      DUP CELL+ CELL+ @REL @            \ link nfa pfa libh
      ROT 1+ DLSYM                      \ link pfa procaddr
      SWAP !
   REPEAT ;

| : /KERNEL-IMPORTS ( -- )
   /HEADER-IMPORTS  OPEN-LIBS  RESOLVE-PROCS ;
