{ ====================================================================
Trap handler

Copyright 2008  FORTH, Inc.

Memory structures documented at the end of this file.
====================================================================

Top of machine stack on entry to <EXCEPTION>

 +0  Return addr
 +4  SIG#
 +8  Pointer to siginfo_t structure
+12  Pointer to ucontext_t structure (see below)

==================================================================== }

TARGET

LABEL <EXCEPTION>
   04 [ESP] EAX MOV                     \ EAX = EXCEPTION#
   EBX PUSH   ESI PUSH   EDI PUSH       \ Save registers for return to OS
   24 [ESP] EBX MOV   28 [EBX] EBX MOV  \ EBX = Machine context
   BEGIN ( *)  0 # EDX MOV              \ Data space origin (updated by /EXCEPTION)
   EAX EXCEPTION# [EDX] MOV             \ Save exception#
   TRACEBACK [EDX] EDI LEA              \ EDI = Address of TRACEBACK buffer in our data space
   12 [EBX] ESI LEA                     \ ESI = ddress of first register in machine context
   #TRACE_REGS # ECX MOV   REP MOVSD    \ Copy registers to TRACEBACK buffer
   40 [EBX] ESI MOV                     \ ESI = Return stack pointed by ESP in machine context
   #TRACE_RSTACK # ECX MOV   REP MOVSD  \ Copy return stack to TRACEBACK buffer
   36 [EBX] ESI MOV                     \ ESI = Data stack pointed by EBP in machine context
   #TRACE_DSTACK # ECX MOV   REP MOVSD  \ Copy data stack to TRACEBACK buffer
   'CATCHING [EDX] EAX LEA   ESP EDI MOV
   $8000 # ECX MOV   REPNE SCASD        \ Find CATCH stack frame
   0= IF   8 [EDI] EAX MOV              \ Get pushed ESI (user pointer)
   EAX 32 [EBX] MOV   THEN              \ Replace ESI in context record so THROW will work correctly
   THROWBACK [EDX] EAX LEA              \ CStuff THROWBACK addr in place of EIP in context record
   EAX 52 [EBX] MOV                     \ Stuff THROWBACK in place of EIP
   EDI POP   ESI POP   EBX POP          \ Restore registers
   EAX EAX XOR   RET   END-CODE         \ Return 0 result

( *) 1+ EQU 'ORIGIN

CREATE SA   <EXCEPTION> ORIGIN + , 0 , $40 , \ struct sigaction

| : /EXCEPTION ( -- )
   ORIGIN 'ORIGIN +ORIGIN !     \ Stuff ORIGIN address into literal
   4 SA 0 sigaction DROP        \ SIGILL - Illegal instruction
   8 SA 0 sigaction DROP        \ SIGFPE - Arithmetic exception
   10 SA 0 sigaction DROP       \ SIGBUS - Bus error
   11 SA 0 sigaction DROP       \ SIGSEGV - Seg fault
   2 SA 0 sigaction DROP        \ SIGINT - User interrupt (Ctrl-C)
;


\\ =====================================================================

_STRUCT_UCONTEXT
{
        int                     uc_onstack;     // +0
        __darwin_sigset_t       uc_sigmask;     // +4
        _STRUCT_SIGALTSTACK     uc_stack;       // +8
        _STRUCT_UCONTEXT        *uc_link;       // +20
        __darwin_size_t         uc_mcsize;      // +24
        _STRUCT_MCONTEXT        *uc_mcontext;   // +28
};

_STRUCT_SIGALTSTACK
{
        void            *ss_sp;
        __darwin_size_t ss_size;
        int             ss_flags;
};


_STRUCT_MCONTEXT32
{
        _STRUCT_X86_EXCEPTION_STATE32   __es;   // +0
        _STRUCT_X86_THREAD_STATE32      __ss;   // +12
        _STRUCT_X86_FLOAT_STATE32       __fs;   // +76
};

_STRUCT_X86_EXCEPTION_STATE32
{
        __uint16_t      __trapno;               // +0
        __uint16_t      __cpu;                  // +2
        __uint32_t      __err;                  // +4
        __uint32_t      __faultvaddr;           // +8
};

_STRUCT_X86_THREAD_STATE32
{
    unsigned int        __eax;                  // +12
    unsigned int        __ebx;                  // +16
    unsigned int        __ecx;                  // +20
    unsigned int        __edx;                  // +24
    unsigned int        __edi;                  // +28
    unsigned int        __esi;                  // +32
    unsigned int        __ebp;                  // +36
    unsigned int        __esp;                  // +40
    unsigned int        __ss;                   // +44
    unsigned int        __eflags;               // +48
    unsigned int        __eip;                  // +52
    unsigned int        __cs;                   // +56
    unsigned int        __ds;                   // +60
    unsigned int        __es;                   // +64
    unsigned int        __fs;                   // +68
    unsigned int        __gs;                   // +72
};


   2 # AL CMP   0= IF   -28 # EBX MOV   THEN    \ SIGINT
   8 # AL CMP   0= IF   -10 # EBX MOV   THEN    \ SIGFPE
   10 # AL CMP   0= IF   -9 # EBX MOV   THEN    \ SIGBUS
   11 # AL CMP   0= IF   -9 # EBX MOV   THEN    \ SIGSEGV
