{ ====================================================================
Input parsing

Copyright 2001  FORTH, Inc.
Rick VanNorman

==================================================================== }

TARGET

{ --------------------------------------------------------------------
Parsing

PARSE parses ccc delimited by the delimiter char. Returns c-addr, the
address (within the input buffer) and u, the length of the parsed
string. If the parse area was empty, returns length=0.

WORD is the principle Forth parser. It skips over leading occurances
of the delimiter, then scans the text for either another delimiter or
the end of the input stream. The parsed string is placed as a counted
string at HERE with trailing blanks. The user variables >IN and IN>
are updated.

PARSE-WORD skips leading spaces and parses name delimited by a space.
Return values same as PARSE. Note that unlike PARSE and WORD, there is
no explicit delimiter given; BL is implied.
------------------------------------------------------------------------ }

: PARSE ( char "ccc<char>" -- c-addr u )
   /SOURCE  OVER >R  ROT SCAN  R>  ROT OVER -  ROT 0<>
   1 AND OVER + >IN +! ;

: WORD ( char "<chars>ccc<char>" -- c-addr )
   /SOURCE OVER >R   2 PICK  SKIP DROP R> - >IN +!
   /SOURCE DROP 'TIB @ - IN> !  PARSE  DUP IN> CELL+ !
   HERE C!  HERE COUNT CMOVE  HERE ;

: PARSE-WORD ( "<spaces>name" -- c-addr u )
   /SOURCE OVER >R  BL SKIP DROP R> - >IN +!  BL PARSE ;

: PARSE-NAME ( "<spaces>name" -- c-addr u )   PARSE-WORD ;