{ ====================================================================
Optimizer patterns

Copyright 2001  FORTH, Inc.
==================================================================== }

HOST

: 2DUP-COMPARE ( -- )   [+ASSEMBLER]
   PUSH(EBX)   EBX CELL [EBP] CMP   0 # EBX MOV
   HERE(T) 3 + 0 RULEX   EBX DEC
   [PREVIOUS] ;


OPTIMIZE 2DUP <     WITH 2DUP-COMPARE   ASSEMBLE JGE
OPTIMIZE 2DUP >     WITH 2DUP-COMPARE   ASSEMBLE JLE
OPTIMIZE 2DUP <=    WITH 2DUP-COMPARE   ASSEMBLE JG
OPTIMIZE 2DUP >=    WITH 2DUP-COMPARE   ASSEMBLE JL
OPTIMIZE 2DUP =     WITH 2DUP-COMPARE   ASSEMBLE JNZ
OPTIMIZE 2DUP <>    WITH 2DUP-COMPARE   ASSEMBLE JZ
OPTIMIZE 2DUP U<    WITH 2DUP-COMPARE   ASSEMBLE JAE
OPTIMIZE 2DUP U>    WITH 2DUP-COMPARE   ASSEMBLE JBE

{ ----------------------------------------------------------------------
---------------------------------------------------------------------- }

: 2DUP-LIT ( -- )
   [+ASSEMBLER]
   -3 CELLS [EBP] EBP LEA   3 CELLS [EBP] EAX MOV
   EBX 0 [EBP] MOV   EBX 2 CELLS [EBP] MOV
   EAX CELL [EBP] MOV   LASTLIT @ # EBX MOV
   [PREVIOUS] ;

OPTIMIZE 2DUP (LITERAL) WITH 2DUP-LIT

{ --------------------------------------------------------------------
-------------------------------------------------------------------- }

: 2DUP-OVER ( -- )
   [+ASSEMBLER]
   -3 CELLS [EBP] EBP LEA   EBX 0 [EBP] MOV
   EBX 2 CELLS [EBP] MOV   3 CELLS [EBP] EBX MOV
   EBX CELL [EBP] MOV
   [PREVIOUS] ;

OPTIMIZE 2DUP OVER WITH 2DUP-OVER

{ --------------------------------------------------------------------
-------------------------------------------------------------------- }

: 2OVER-ALU ( -- )
   [+ASSEMBLER]
   PUSH(EBX)   3 CELLS [EBP] EBX MOV
   2 CELLS [EBP] EBX 0 RULEX
   [PREVIOUS] ;

OPTIMIZE 2OVER +   WITH  2OVER-ALU ASSEMBLE ADD
OPTIMIZE 2OVER -   WITH  2OVER-ALU ASSEMBLE SUB
OPTIMIZE 2OVER AND WITH  2OVER-ALU ASSEMBLE AND
OPTIMIZE 2OVER OR  WITH  2OVER-ALU ASSEMBLE OR
OPTIMIZE 2OVER XOR WITH  2OVER-ALU ASSEMBLE XOR

{ --------------------------------------------------------------------
-------------------------------------------------------------------- }

: 2DUP-ALU ( -- )
   [+ASSEMBLER]
   PUSH(EBX)   CELL [EBP] EAX MOV
   EBX EAX 0 RULEX   EAX EBX MOV
   [PREVIOUS] ;

OPTIMIZE 2DUP +   WITH  2DUP-ALU ASSEMBLE ADD
OPTIMIZE 2DUP -   WITH  2DUP-ALU ASSEMBLE SUB
OPTIMIZE 2DUP AND WITH  2DUP-ALU ASSEMBLE AND
OPTIMIZE 2DUP OR  WITH  2DUP-ALU ASSEMBLE OR
OPTIMIZE 2DUP XOR WITH  2DUP-ALU ASSEMBLE XOR

{ --------------------------------------------------------------------
-------------------------------------------------------------------- }

: 2DUP-ALU->R ( -- )
   [+ASSEMBLER]
   0 [EBP] EAX MOV   EBX EAX 1 RULEX   EAX PUSH
   [PREVIOUS] ;

OPTIMIZE 2DUP-ALU >R WITH 2DUP-ALU->R

: 2OVER-ALU->R ( -- )
   [+ASSEMBLER]
   2 CELLS [EBP] EAX MOV   CELL [EBP] EAX 1 RULEX   EAX PUSH
   [PREVIOUS] ;

OPTIMIZE 2OVER-ALU >R WITH 2OVER-ALU->R

{ --------------------------------------------------------------------
-------------------------------------------------------------------- }

: 2DUP-CMP-IF ( -- )
   [+ASSEMBLER]
   EBX 0 [EBP] CMP   HERE(T) $400 + 1 RULEX
   [PREVIOUS] ;

OPTIMIZE 2DUP-COMPARE (IF) WITH 2DUP-CMP-IF

{ --------------------------------------------------------------------
-------------------------------------------------------------------- }

: LIT-STAR ( -- )
   [+ASSEMBLER]
   LASTLIT @ # EAX MOV   EBX MUL   EAX EBX MOV
   [PREVIOUS] ;

: LIT-DIV ( -- )
   [+ASSEMBLER]
   EBX EAX MOV   CDQ   LASTLIT @ # EBX MOV
   EBX IDIV   EAX EBX MOV
   [PREVIOUS] ;

: LIT-MOD ( -- )
   [+ASSEMBLER]
   EBX EAX MOV   CDQ   LASTLIT @ # EBX MOV
   EBX IDIV   EDX EBX MOV
   [PREVIOUS] ;

OPTIMIZE (LITERAL) *   WITH LIT-STAR
OPTIMIZE (LITERAL) /   WITH LIT-DIV
OPTIMIZE (LITERAL) MOD WITH LIT-MOD

{ --------------------------------------------------------------------
-------------------------------------------------------------------- }

: 2DROP-LIT ( -- )
   [+ASSEMBLER]
   CELL [EBP] EBP LEA   LASTLIT @ # EBX MOV
   [PREVIOUS] ;

OPTIMIZE 2DROP (LITERAL) WITH 2DROP-LIT

: 3DROP-LIT ( -- )
   [+ASSEMBLER]
   2 CELLS [EBP] EBP LEA   LASTLIT @ # EBX MOV
   [PREVIOUS] ;

OPTIMIZE 3DROP (LITERAL) WITH 3DROP-LIT

{ --------------------------------------------------------------------
-------------------------------------------------------------------- }

: LIT-/STRING ( -- )
   [+ASSEMBLER]
   LASTLIT @ # 0 [EBP] ADD   LASTLIT @ # EBX SUB
   [PREVIOUS] ;

OPTIMIZE (LITERAL) /STRING WITH LIT-/STRING

OPTIMIZE TWO-LITERALS *      WITH 2LIT-ALU WITH *
OPTIMIZE TWO-LITERALS /      WITH 2LIT-ALU WITH /

{ --------------------------------------------------------------------
-------------------------------------------------------------------- }

: 2LIT-D+ ( -- )
   [+ASSEMBLER]
   LASTLIT CELL+ @ # 0 [EBP] ADD   LASTLIT @ # EBX ADC
   [PREVIOUS] ;

OPTIMIZE TWO-LITERALS D+ WITH 2LIT-D+

{ --------------------------------------------------------------------
-------------------------------------------------------------------- }

: -ROT-LIT-/STRING ( -- )
   ['] -ROT (COMPILE,)  LIT-/STRING ;

OPTIMIZE -ROT LIT-/STRING WITH -ROT-LIT-/STRING

: -ROT-LIT-/STRING-ROT ( -- )
   [+ASSEMBLER]
   LASTLIT @ # CELL [EBP] ADD   LASTLIT @ # 0 [EBP] SUB
   [PREVIOUS] ;

OPTIMIZE -ROT-LIT-/STRING ROT WITH -ROT-LIT-/STRING-ROT

: LIT->BODY! ( -- )
   [+ASSEMBLER]
   EBX LASTLIT @ 5 + [EDI] MOV   POP(EBX)
   [PREVIOUS] ;

OPTIMIZE (LITERAL) >BODY! WITH LIT->BODY!

: 2LIT->BODY! ( -- )
   [+ASSEMBLER]
   LASTLIT CELL+ @ # LASTLIT @ 5 + [EDI] MOV
   [PREVIOUS] ;

OPTIMIZE TWO-LITERALS >BODY! WITH 2LIT->BODY!

: LIT->BODY+! ( -- )
   [+ASSEMBLER]
   EBX LASTLIT @ 5 + [EDI] ADD   POP(EBX)
   [PREVIOUS] ;

OPTIMIZE (LITERAL) >BODY+! WITH LIT->BODY+!

: 2LIT->BODY+! ( -- )
   [+ASSEMBLER]
   LASTLIT CELL+ @ # LASTLIT @ 5 + [EDI] ADD
   [PREVIOUS] ;

OPTIMIZE TWO-LITERALS >BODY+! WITH 2LIT->BODY+!

: LIT->BODY ( -- )
   [+ASSEMBLER]
   PUSH(EBX)   LASTLIT @ 5 + [EDI] EBX LEA
   [PREVIOUS] ;

OPTIMIZE (LITERAL) >BODY WITH LIT->BODY

{ --------------------------------------------------------------------
-------------------------------------------------------------------- }

: LIT->BODY-LIT+ ( -- )
   [+ASSEMBLER]
   LASTLIT 2@ + LASTLIT !   PUSH(EBX)
   LASTLIT @ 5 + [EDI] EBX LEA
   [PREVIOUS] ;

OPTIMIZE LIT->BODY LIT-PLUS WITH LIT->BODY-LIT+

TARGET
