{ ====================================================================
Compile the SwiftForth kernel

Copyright 2001  FORTH, Inc.

==================================================================== }

EMPTY  -OPT   $11 WARNING CELL+ !

INCLUDE %SwiftForth\XComp\i386\tc       \ Target compiler

INCLUDE config                  \ Kernel configuration
INCLUDE ..\nucleus              \ SwiftForth nucleus
INCLUDE ..\data                 \ User variable and system data
INCLUDE ..\except               \ Catch and throw
INCLUDE ..\core                 \ Forth core wordset
INCLUDE ..\patterns
/OPTIMIZER
TARGET
INCLUDE ..\personality          \ Vectored I/O personality support
INCLUDE ..\double               \ Double numbers
INCLUDE ..\stringops            \ String operators
INCLUDE ..\warning              \ Warnings
INCLUDE ..\dictionary           \ Dictionary structure; relative pointers
INCLUDE ..\math                 \ Math operators
include ..\patterns2
INCLUDE ..\wordlist             \ wordlists
INCLUDE ..\imports              \ external libraries
INCLUDE imports                 \ external libraries
INCLUDE trap                    \ Trap OS exceptions
INCLUDE allocate                \ heap management
INCLUDE fileops                 \ File operations
INCLUDE ..\compiler             \ Compiler support
INCLUDE ..\output               \ Formatted output
INCLUDE ..\accept               \ User input
INCLUDE ..\parser               \ Input parsing
INCLUDE ..\find                 \ Dictionary search
INCLUDE ..\heads                \ Dictionary heads
INCLUDE ..\number               \ Input number conversion
INCLUDE ..\interp               \ Interpreter support
INCLUDE filepath                \ Win32 file and path names
INCLUDE ..\files                \ File operations
INCLUDE ..\struct               \ Structured transfers
INCLUDE ..\defining             \ Defining words
INCLUDE ..\strings2             \ String compiling and output
INCLUDE ..\switch               \ Execution switches
INCLUDE ..\dump                 \ Hex memory dump
INCLUDE console                 \ Console-mode user interface
INCLUDE ..\released             \ Version#, copyright, release date
INCLUDE args                    \ Command-line args
INCLUDE ../legacy               \ Legacy memory access words

| : SYSTEM-NAME ( -- addr u )   S" Win32 " ;
| : HI-PATH ( -- addr u )   S" %SwiftForth\src\ide\win32\hi.f" ;

INCLUDE ..\start                \ Common start-up
INCLUDE start                   \ Win32 start-up
INCLUDE save                    \ Write PE file to disk

HERE NEGATE 3 AND ALLOT         \ Cell-align dictionary pointer
HERE DP0 !REL(T)                \ Initial empty dictionary pointer
HERE 'TREF !REL(T)  ,TREFS      \ Cross-ref list (dictionary will over-write after one-time /SREF init)
POWER-UP 0 !                    \ Entry point offset in first cell of image for PE loader

=FORTH =STRANDS SET-STRANDS
=FILES SET-FILES
INTERPRETER TF# @ DUP TARGET F# ! F# CELL+ !

HOST CHECK-FORWARD-REFERENCES TARGET

SAVE-KERNEL %SwiftForth\bin\sfk.exe
HOST
