{ =====================================================================
Generate portable executable object file

Copyright 2000  FORTH, Inc.

The Windows PE header for use with SwiftForth executables is copied in
from the binary image in the file %SwiftForth\bin\sf-loader.bin.

Reference: https://docs.microsoft.com/en-us/windows/win32/debug/pe-format

===================================================================== }

HOST  HEX

: SAVE-KERNEL ( -- )
   HERE(T) 200 CHUNK  DUP >R                    \ Extra size to insert SwiftForth image
   S" %SwiftForth\bin\sf-loader.bin"            \ Loader image file
   READ-IMAGE  SCAN-HEADER                      \ Read the PE header into memory, scan header
   R@ PE-HEADER SizeOfInitializedData L+!       \ Add kernel size to SizeOfInitializedData
   R> .forth SizeOfRawData L!                   \ Set SizeOfRawData in Forth section
   3 PE-HEADER Subsystem W!                     \ Set console mode (03) in Subsystem field
   0 >IMAGE  #LOADER @ +IMG                     \ Source from target-compiled program, dest after PE header in image
   HERE(T) CMOVE                                \ Copy SwiftForth into file image
   CHECKSUM-IMAGE PE-HEADER CheckSum !          \ Set the new checksum in the header
   SAVE-IMAGE ;                                 \ Save binary image

INTERPRETER

: SAVE-KERNEL  SAVE-KERNEL ;

DECIMAL  TARGET
